












!m  Program Name:
!  Author(s)/Contact(s): Wei Yu
! 
!  User controllable options: <if applicable>

program data_hydro
! This is the main program of data hydrology model 

   use module_dhydro, only: dhydro_ini, dhydro_exe, dabiaLoop, interFace_drv0,interFace_drv
   use module_namelist, only: nlst_rt
   use module_channelUpdate, only:  bias2m
   use module_rami_hybridDa, only: segInfoFile
   use module_mpp_land, only: my_id, io_id, global_rt_nx, global_rt_ny
   use module_noahmp_hrldas_driver, only: land_driver_ini, land_driver_exe, olddate,reset_rst
   use module_dhydro, only : factor, dhydro_adjust
   use module_RT_data, only: rt_domain
   
   

   implicit none

   integer :: k, dabiaLoopOpt, did, mLoop
   integer :: ITIME, NTIME

   parameter(did = 1)
   character(len=1) ss
   logical :: fexist
   



!   print*, " DABE = ", nlst_rt(did)%DABE, "dabiaLoop = ", dabiaLoop
!yw   call land_driver_ini(NTIME)

   call interFace_drv()
   call dhydro_ini()

  write(6,*) "step 1  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt


   if(nlst_rt(did)%DABE .eq. 0) dabiaLoop = 0

   write(6,*) " DABE = ", nlst_rt(did)%DABE, "dabiaLoop = ", dabiaLoop


   mLoop = 0
   if(dabiaLoop .gt. 0) mLoop = dabiaLoop

   write(6,*) "step 2  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt


   do k = 0, mLoop
  
   if(nlst_rt(did)%CHANRTSWCRT .ne. 0) then
      if(dabiaLoop .gt. 0 .or. dabiaLoop .lt. 0) call daBiaLoop_ini_drv()
   endif
       if(my_id .eq. io_id) then
          write(ss,"(I1)") k
          inquire (file=trim(ss), exist=fexist)
          if(.not. fexist) call system("mkdir "//ss)
          inquire (file=trim(segInfoFile), exist=fexist)
          if(fexist) call system("cp "//trim(segInfoFile)//" "//ss)
          inquire (file="factor.nc", exist=fexist)
          if(fexist) call system("cp factor.nc "//ss)
       endif

       call resetIni()

   write(6,*) "step 3  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt
!!!! run NoahMP
       call interFace_drv0()

       RT_DOMAIN(did)%initialized = .false.
       if(k .eq. 0) then
           call land_driver_ini(NTIME)
       else
           call reset_rst()
       endif
       write(6,*) "step 4  global_rt_nx,global_rt_ny = ", global_rt_nx,global_rt_ny, rt_domain(did)%ixrt,rt_domain(did)%jxrt
       write(6,*) "after land_driver_ini ", NTIME, mLoop
       call flush(6)


       call aggFactor(k)
      
       write(6,*) "before land_driver_exe, ntime, dhydroFlag ", NTIME, nlst_rt(did)%dhydroFlag
       call flush(6)

!!       call readCHNC_drv()

       do ITIME = 1, NTIME
           call land_driver_exe(ITIME)

           call dhydro_adjust(olddate,ITIME)
       end do

       call interFace_drv()

        if(dabiaLoop .gt. 0 .or. dabiaLoop .lt. 0) call dumpPair_drv(k)
        if( k .ne. mLoop .or. dabiaLoop .ne. 0) then
            call daBiaRun_drv(k,dabiaLoop)
        endif
   enddo
   call hydro_finish()
END 


      subroutine aggFactor(unit)
      
       use module_mpp_land, only:  sum_real1, my_id, io_id, numprocs
       use module_dhydro, only :read_factor, factor
       use module_noahmp_hrldas_driver, only: factorLnd
       use module_mpp_land, only: left_id, down_id
       use module_namelist, only: nlst_rt
       use module_RT_data, only: rt_domain
     
       implicit none

       integer :: unit
       integer :: did
       ! real, dimension(rt_domain(1)%ixrt,rt_domain(1)%jxrt) :: factor
       parameter(did = 1)
       

       integer :: i, j, krt, ixxrt, jyyrt, &
                  AGGFACYRT, AGGFACXRT
       integer :: k, kk, count

       real    :: tmp

       
       factorLnd = 1
!!!! for river grid, if there is water, set the soil to be saturated.

!        call read_factor(factor,rt_domain(did)%ixrt,rt_domain(did)%jxrt)
        call get2d_real_rt_lnd_mp("factor",factor,rt_domain(did)%ixrt,rt_domain(did)%jxrt,"factor.nc")

        do J=1,rt_domain(did)%JX
          do I=1,rt_domain(did)%IX

             tmp = 0.
             count = 0

             do AGGFACYRT=nlst_rt(did)%AGGFACTRT-1,0,-1
              do AGGFACXRT=nlst_rt(did)%AGGFACTRT-1,0,-1

                IXXRT=I*nlst_rt(did)%AGGFACTRT-AGGFACXRT
                JYYRT=J*nlst_rt(did)%AGGFACTRT-AGGFACYRT

                if(left_id.ge.0) IXXRT=IXXRT+1
                if(down_id.ge.0) JYYRT=JYYRT+1

!State Variables
                !! if(RT_DOMAIN(did)%domain_msk(IXXRT,JYYRT) .gt. 0 .and. factor(IXXRT,JYYRT) .ne. 1) then
                if(RT_DOMAIN(did)%domain_msk(IXXRT,JYYRT) .gt. 0 ) then
                      tmp = tmp + factor(IXXRT,JYYRT)
                      count = count + 1
                endif
              end do
             end do

            if(count .gt. 0) then 
                 factorLnd(I,J) = tmp  / count
                 factorLnd(I,J) = max(factorLnd(I,J), nlst_rt(did)%factor1dLow)
                 factorLnd(I,J) = min(factorLnd(I,J), nlst_rt(did)%factor1dHigh)
                 if(factorLnd(I,J) .eq. 0) factorLnd(I,J) = 1
            endif
!!            write(80+unit,*) factorLnd(I,J)
         end do
        end do

      end subroutine aggFactor
